local bump = require "bump"

TileTable = {
		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 },
		{ 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1 },
		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 },
		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
	}
TileW, TileH = 32, 32

player = {}
player.x = 32
player.xvel = 0
player.y = 32
player.yvel = 0
player.width = 8
player.height = 8
player.speed = 128
player.jSpeed = -8192
player.gravity = 256
player.jConstant = nil

block = {}
block.x = 0
block.y = 64
block.w = 100
block.h = 100

local col_len = 0
local world = bump.newWorld()

function love.load()
	world:add(player, player.x, player.y, player.width, player.height)
	world:add(block, block.x, block.y, block.w, block.h)
end

local dx, dy = player.xvel,player.yvel
function love.update(dt)
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	player.yvel = player.yvel + player.gravity * dt

	--left and right control
	lk = love.keyboard
	if lk.isDown("d") and player.xvel < player.speed then
		player.xvel = player.xvel + player.speed * dt
	end
	if lk.isDown("a") and player.xvel > -player.speed then
		player.xvel = player.xvel - player.speed * dt
	end

	-- is no keys or both keys are down then set the polishable jumps
	if (lk.isDown("a") and lk.isDown("d")) or (not lk.isDown("a") and not lk.isDown("d")) then
		player.jConstant = true
	else
		player.jConstant = false
	end
	if (player.xvel > 0 and love.keyboard.isDown("a")) or (player.xvel < 0 and love.keyboard.isDown("d")) then
		player.jConstant = true
	end
	print(dx, dy)

	-- collision?
	if player.xvel ~= 0 or player.yvel ~= 0 then
		player.x, player.y, _, col_len = world:move(player, player.x + dx, player.y + dy)
	end

	local cols, len = world:check(player, 0, 0)
	if len > 0 then
		player.yvel = 0
	end
end
function love.draw()
	for rowIndex=1, #TileTable do
    	local row = TileTable[rowIndex]
    	for columnIndex=1, #row do
      		local number = row[columnIndex]
      		if number == 1 then
      			love.graphics.setColor(42,58,47)
      			love.graphics.rectangle("fill", (columnIndex-1)*TileW, (rowIndex-1)*TileH, TileW, TileH)
      		else
      			love.graphics.setColor(243,235,189)
      			love.graphics.rectangle("fill", (columnIndex-1)*TileW, (rowIndex-1)*TileH, TileW, TileH)
      		end
    	end
  	end
  	love.graphics.setColor(255,0,0,150)
  	love.graphics.rectangle("line", block.x, block.y, block.w, block.h)
  	love.graphics.setColor(131,167,225)
  	love.graphics.rectangle("fill", player.x, player.y, player.width, player.height)
end
function love.keypressed(key)
	if key == 'escape' then
		love.event.quit()
	end

	dt = love.timer.getDelta()
	if key == 'w' then
		if player.jConstant then
			player.xvel = player.xvel / 4
		end
		player.yvel = 0
		player.yvel = player.yvel + player.jSpeed * dt
	end
end

function window_width()
	for rowIndex=1, #TileTable do
		local row = TileTable[rowIndex]
		return #row*TileW
	end
end
function window_height()
	return #TileTable*TileH
end